Attribute VB_Name = "Sample"
'============================================================================
'
'  aPCI-P54
'
'  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'  V1.11 Date 1999/09/10
'
'   ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'
'============================================================================
Option Explicit

Private Const szTitle = "Sample"
Private Const szP54 = "aPCI-P54"
Private Declare Function GetLastError Lib "kernel32" () As Long

'============================================================================
'   ۸т̊Jn
'============================================================================
Sub Main()

  Dim wLogSlot As Integer      ' ޲̘_ۯĔԍi[
  Dim Ri As APCI54RESOURCE     ' ؿ
  Dim dwDllVer As Long, dwDriverVer As Long
  Dim dwSwVal As Long          ' ۰ذ̒l
  Dim dwDirections As Long     ' ިڸ
  Dim cbDat As Byte
  Dim bResult As Boolean       ' 
  Dim szBuf As String

  '-------------------------------------------------
  ' apci54.dll ̎gp錾
  '-------------------------------------------------
  If Apci54wDllOpen() = False Then
    ErrorMessage (APCI54_SLOT_AUTO)
    Exit Sub                   ' apci54.dll ۰ނɎs܂
  End If
  '-------------------------------------------------
  ' ްޮݔԍ\
  ' aPCI-P54 DLL,ײްްޮݔԍ擾
  '-------------------------------------------------
  If Apci54wGetVersion(dwDllVer, dwDriverVer) = False Then
    ErrorMessage (APCI54_SLOT_AUTO)
    Exit Sub
  End If

  szBuf = "GetVersion" + Chr(10) + _
          "DLL    Version" + Chr(9) + ": &H" + Hex(dwDllVer) + Chr(10) + _
          "Driver Version" + Chr(9) + ": &H" + Hex(dwDriverVer)
  ResultMessage (szBuf)
  '-------------------------------------------------
  ' aPCI-P54̎gp錾
  '-------------------------------------------------
  wLogSlot = APCI54_SLOT_AUTO            ' gp޲T܂B
  bResult = Apci54wCreate(wLogSlot)      ' ꍇA̎޲̘_ۯĔԍi[܂B

  If bResult = False Then                ' ޲܂B
    ErrorMessage (APCI54_SLOT_AUTO)
    Exit Sub
  End If

  szBuf = "aPCI-P54 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)
  ResultMessage (szBuf)
  '-------------------------------------------------
  ' ؿ۰ذ̒l擾
  '-------------------------------------------------
  If Apci54wGetResource(wLogSlot, Ri) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  If Apci54wGetSwitchValue(wLogSlot, dwSwVal) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  szBuf = "Board Name  " + Chr(9) + ": " + szP54 + Chr(10) + _
          "IO Address  " + Chr(9) + ": &H" + Hex(Ri.dwIOPortBase(1)) + _
          "-&H" + Hex(Ri.dwIOPortBase(1) + Ri.dwIOPortLength(1) - 1) + Chr(10) + _
          "Switch      " + Chr(9) + ": &H" + Hex(dwSwVal)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' Port A ިڸ݂o͂ɐݒ肷
  '-------------------------------------------------
  If Apci54wGetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  dwDirections = (Not APCI54_DIR_A_INPUT) And dwDirections   ' A Port ޯĂo͂ɕύX܂B
  If Apci54wSetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("Port A ̃fBNVo͂ɕύX")
  '-------------------------------------------------
  ' Port A ɔCӂ̃f[^o
  '-------------------------------------------------
  cbDat = &HAA
  If Apci54wOutPort(wLogSlot, APCI54_PORT_A, cbDat) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If

  szBuf = "Port A փf[^o" + Chr(10) + _
          "Port A Out Data: &H" + Hex(cbDat)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' Port A ިڸ݂͂ɐݒ
  '-------------------------------------------------
  If Apci54wGetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  dwDirections = APCI54_DIR_A_INPUT Or dwDirections   ' A Port ޯĂ͂ɕύX܂B
  If Apci54wSetDirections(wLogSlot, dwDirections) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("Port A ̃fBNV͂ɕύX")
  '-------------------------------------------------
  ' Port A f[^ǂݍ
  '-------------------------------------------------
  cbDat = &H0
  If Apci54wInPort(wLogSlot, APCI54_PORT_A, cbDat) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  szBuf = "Port A f[^" + Chr(10) + _
          "Port A In Data: &H" + Hex(cbDat)

  ResultMessage (szBuf)
  '-------------------------------------------------
  ' aPCI-P54̎gpJ
  '-------------------------------------------------
  If Apci54wClose(wLogSlot) = False Then
    ErrorMessage (wLogSlot)
    Exit Sub
  End If
  ResultMessage ("aPCI-P54 Closed")
  '-------------------------------------------------
  ' apci54.dll ̎gpJ
  '-------------------------------------------------
  If Apci54wDllClose() = False Then
    MsgBox "DLL ̃A[hɎs܂B", vbOKOnly + vbCritical
    Exit Sub
  End If
End Sub
'============================================================================
'    ʂ\
'============================================================================
Private Sub ResultMessage(lpszbuf As String)
  MsgBox lpszbuf, vbOKOnly + vbInformation
End Sub
'============================================================================
'    G[bZ[W\
'============================================================================
Private Sub ErrorMessage(ByVal wLogSlot As Integer)
  Dim dwRes As Long
  Dim szBuf As String

  dwRes = Apci54wGetLastError(wLogSlot)
  Select Case dwRes
    Case APCI54_ERR_SYSTEM
      szBuf = "System error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(GetLastError())
    Case APCI54_ERR_WRAPDLL
      szBuf = "DLL Load error"
    Case Else
      szBuf = "aPCI-P54 error" + Chr(10) + Chr(10) + "Error code: &H" + Hex(dwRes)
  End Select
  MsgBox szBuf, vbOKOnly + vbCritical
End Sub

