//============================================================================
//	apci54w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/09/10
//
//============================================================================

unit apci54w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI54_SUCCESS				      = 0;	// I
	APCI54_ERR_SYSTEM			      = 1;	// GetLastError sĂ
	APCI54_ERR_NO_DEVICE		    = 2;	// gp\޲Ȃ
	APCI54_ERR_IN_USE			      = 3;	// w肳ꂽ޲͎gp
	APCI54_ERR_INVALID_SLOT		  = 4;  // Ș_ۯĔԍw肵
	APCI54_ERR_RESOURCE			    = 5;	// ؿװ
	APCI54_ERR_INVALID_PORT     = 6;	// ߰Ăv
	APCI54_ERR_INVALID_ARGUMENT = 7;	// Ȉv
	APCI54_ERR_NO_CREATE				= 8;	// ޲شĂĂ܂
	APCI54_ERR_WRAPDLL 					=Dword(-1); 	// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI54_PORT_A	= 0;
	APCI54_PORT_B	= 1;
	APCI54_PORT_C	= 2;
	APCI54_PORT_D	= 3;
	APCI54_PORT_E	= 4;
	APCI54_PORT_F	= 5;
//-------------------------------------
// ߰Ăިڸݒ萔
//-------------------------------------
	APCI54_DIR_A_OUTPUT	=	$00;
	APCI54_DIR_A_INPUT	=	$01;
	APCI54_DIR_B_OUTPUT	=	$00;
	APCI54_DIR_B_INPUT	=	$02;
	APCI54_DIR_C_OUTPUT	=	$00;
	APCI54_DIR_C_INPUT	=	$04;
	APCI54_DIR_D_OUTPUT	=	$00;
	APCI54_DIR_D_INPUT	=	$08;
	APCI54_DIR_E_OUTPUT	=	$00;
	APCI54_DIR_E_INPUT	=	$10;
	APCI54_DIR_F_OUTPUT	=	$00;
	APCI54_DIR_F_INPUT	=	$20;
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI54_DLL_NAME 	= 'apci54.dll';	// DLĻٖ
	APCI54_MAX_PORTS	= 6;						// ߰Đ
	APCI54_MAX_SLOTS	= 16;						// őۯĐ
	APCI54_DEVICE_ID	= $136c9054;		// ޲ID
	APCI54_SLOT_AUTO	= $ffff;				// AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI54_MAX_MEM	=	 9;
	APCI54_MAX_IO		= 20;
	APCI54_MAX_IRQ	=	 7;
	APCI54_MAX_DMA	=	 7;

type
	TAPCI54RESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI54_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI54_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI54_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI54_MAX_IO] of		DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI54_MAX_IO] of		DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI54_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI54_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI54_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI54_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of								DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci54wDllOpen: Boolean;
// DLL ۰
function Apci54wDllClose: Boolean;
// aPCI-P54 DLL,޲ײްްޮݔԍ擾
function Apci54wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
// CӂaPCI-P54̎gp錾
function Apci54wCreate(var pwLogSlot:Word): Boolean;
// CӂaPCI-P54̎gpJ
function Apci54wClose(wLogSlot:Word): Boolean;
// ؿ擾
function Apci54wGetResource(wLogSlot:Word; var pResInfo:TAPCI54RESOURCE): Boolean;
// Cӂ߰Ăް
function Apci54wInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
// Cӂ߰Ăްo
function Apci54wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
// aPCI-P54̴װ
function Apci54wGetLastError(wLogSlot:Word): DWord;
// ۰ذ̒l擾
function Apci54wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;
// ިڸ݂̏Ԃ擾
function Apci54wGetDirections(wLogSlot:Word; var pdwDirections:DWord): Boolean;
// ިڸ݂
function Apci54wSetDirections(wLogSlot:Word; dwDirections:DWord): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci54GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci54Create = function(var pwLogSlot:Word): BOOL; stdcall;
	TApci54Close = function(wLogSlot:WORD): BOOL; stdcall;
	TApci54GetResource = function(wLogSlot:WORD; var pres:TAPCI54RESOURCE): BOOL; stdcall;
	TApci54InPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TApci54OutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
	TApci54GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci54GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;
	TApci54GetDirections = function(wLogSlot:WORD; var pdwDirections:DWORD): BOOL; stdcall;
	TApci54SetDirections = function(wLogSlot:WORD; dwDirections:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci54GetVersion: TApci54GetVersion;
	pApci54Create: TApci54Create;
	pApci54Close: TApci54Close;
	pApci54GetResource: TApci54GetResource;
	pApci54InPort: TApci54InPort;
	pApci54OutPort: TApci54OutPort;
	pApci54GetLastError: TApci54GetLastError;
	pApci54GetSwitchValue: TApci54GetSwitchValue;
	pApci54GetDirections: TApci54GetDirections;
	pApci54SetDirections: TApci54SetDirections;

function Apci54wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci54.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci54wDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(APCI54_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Apci54wGetDllExportFunc;
			if Result <> True then
				Apci54wDllClose;			// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 		apci54.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci54wDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 		aPCI-P54 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci54wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54GetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aPCI-P54̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  True
//				s False
//============================================================================
function Apci54wCreate(var pwLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54Create(pwLogSlot)
end;
//============================================================================
// 		aPCI-P54̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci54wClose(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci54wGetResource(wLogSlot:Word; var pResInfo:TAPCI54RESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				dwLogPort	͂_߰
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci54wInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54InPort(wLogSlot, dwLogPort, pbInValue)
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//				dwLogPort	o͂_߰
//				bOutValue o͂ް
// ߂l  True
//				s False
//============================================================================
function Apci54wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54OutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 		aPCI-P54̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Apci54wGetLastError(wLogSlot:Word): DWord;
begin
	if hDLL = 0 then Result := APCI54_ERR_WRAPDLL
	else Result := pApci54GetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot				۰ذ̒l擾޲̘_ۯĔԍ
// 				pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci54wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54GetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//============================================================================
// 	  ިڸ݂̏Ԃ擾
// 	  wLogSlot			ިڸ݂̏Ԃ擾޲̘_ۯĔԍ
//			  pdwDirections ިڸݏԂi[̈ւ߲
// ߂l  TRUE
//			  s FALSE
//============================================================================
function Apci54wGetDirections(wLogSlot:Word; var pdwDirections:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54GetDirections(wLogSlot, pdwDirections)
end;
//============================================================================
// 	  ިڸ݂Ă
// 	  wLogSlot			ިڸ݂Ă޲̘_ۯĔԍ
//			  dwDirections	Ăިڸ݂̓e
// ߂l  TRUE
//			  s FALSE
//============================================================================
function Apci54wSetDirections(wLogSlot:Word; dwDirections:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci54SetDirections(wLogSlot, dwDirections)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Apci54wGetDllExportFunc: Boolean;
begin
	Result := False;
	// Apci54GetVersion ̱ڽ擾
	pApci54GetVersion := GetProcAddress(hDLL, 'Apci54GetVersion');
	if @pApci54GetVersion = nil then Exit;
	// Apci54Create ̱ڽ擾
	pApci54Create := GetProcAddress(hDLL, 'Apci54Create');
	if @pApci54Create = nil then Exit;
	// Apci54Close ̱ڽ擾
	pApci54Close := GetProcAddress(hDLL, 'Apci54Close');
	if @pApci54Close = nil then Exit;
	// Apci54GetResource ̱ڽ擾
	pApci54GetResource := GetProcAddress(hDLL, 'Apci54GetResource');
	if @pApci54GetResource = nil then Exit;
	// Apci54InPort ̱ڽ擾
	pApci54InPort := GetProcAddress(hDLL, 'Apci54InPort');
	if @pApci54InPort = nil then Exit;
	// Apci54OutPort ̱ڽ擾
	pApci54OutPort := GetProcAddress(hDLL, 'Apci54OutPort');
	if @pApci54OutPort = nil then Exit;
	// Apci54GetLastError ̱ڽ擾
	pApci54GetLastError := GetProcAddress(hDLL, 'Apci54GetLastError');
	if @pApci54GetLastError = nil then Exit;
	// Apci54GetSwitchValue ̱ڽ擾
	pApci54GetSwitchValue := GetProcAddress(hDLL, 'Apci54GetSwitchValue');
	if @pApci54GetSwitchValue = nil then Exit;
	// Apci54GetDirections ̱ڽ擾
	pApci54GetDirections := GetProcAddress(hDLL, 'Apci54GetDirections');
	if @pApci54GetDirections = nil then Exit;
	// Apci54SetDirections ̱ڽ擾
	pApci54SetDirections := GetProcAddress(hDLL, 'Apci54SetDirections');
	if @pApci54SetDirections = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

