Attribute VB_Name = "Wrapper"
'============================================================================
'   aPCI-P54
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   V1.11 Date 1999/09/10
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI54_DLL_NAME = "apci54.dll" ' DLL
Global Const APCI54_ERR_WRAPDLL = -1        ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     apci54.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci54wDllOpen() As Boolean
  Apci54wDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(APCI54_DLL_NAME)
    If hDLL <> 0 Then
      Apci54wDllOpen = Apci54wGetDllExportFunc()
      If Apci54wDllOpen <> True Then
        Apci54wDllClose       ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     apci54.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci54wDllClose() As Boolean
  Apci54wDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Apci54wDllClose = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P54 DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion    DLLްޮݔԍi[
'         pdwDriverVersion ޲ײްްޮݔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci54wGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
  Apci54wGetVersion = False
  If hDLL <> 0 Then
    If Apci54GetVersion(pdwDllVersion, pdwDriverVersion) <> 0 Then
      Apci54wGetVersion = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P54̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci54wCreate(pwLogSlot As Integer) As Boolean
  Apci54wCreate = False
  If hDLL <> 0 Then
    If Apci54Create(pwLogSlot) <> 0 Then
      Apci54wCreate = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P54̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Apci54wClose(ByVal wLogSlot As Integer) As Boolean
  Apci54wClose = False
  If hDLL <> 0 Then
    If Apci54Close(wLogSlot) <> 0 Then
      Apci54wClose = True
    End If
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Apci54wGetResource(ByVal wLogSlot As Integer, pResInfo As APCI54RESOURCE) As Boolean
  Apci54wGetResource = False
  If hDLL <> 0 Then
    If Apci54GetResource(wLogSlot, pResInfo) <> 0 Then
      Apci54wGetResource = True
    End If
  End If
End Function
'============================================================================
'     ۰ذ̒l擾
'     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
'         pdwSwitchValue ۰ذ̒li[
'  ߂l  True
'         s False
'============================================================================
Function Apci54wGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean
  Apci54wGetSwitchValue = False
  If hDLL <> 0 Then
    If Apci54GetSwitchValue(wLogSlot, pdwSwitchValue) <> 0 Then
      Apci54wGetSwitchValue = True
    End If
  End If
End Function
'============================================================================
'     ިڸ݂̏Ԃ擾
'     wLogSlot      ިڸݏ擾޲̘_ۯĔԍ
'         pdwDirections Ԃi[
'  ߂l  True
'         s False
'============================================================================
Function Apci54wGetDirections(ByVal wLogSlot As Integer, pdwDirections As Long) As Boolean
  Apci54wGetDirections = False
  If hDLL <> 0 Then
    If Apci54GetDirections(wLogSlot, pdwDirections) <> 0 Then
      Apci54wGetDirections = True
    End If
  End If
End Function
'============================================================================
'     ިڸ݂
'     wLogSlot     ިڸݏݒ肷޲̘_ۯĔԍ
'         dwDirections Ăe
'  ߂l  True
'         s False
'============================================================================
Function Apci54wSetDirections(ByVal wLogSlot As Integer, ByVal dwDirections As Long) As Boolean
  Apci54wSetDirections = False
  If hDLL <> 0 Then
    If Apci54SetDirections(wLogSlot, dwDirections) <> 0 Then
      Apci54wSetDirections = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Apci54wInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
  Apci54wInPort = False
  If hDLL <> 0 Then
    If Apci54InPort(wLogSlot, dwLogPort, pbInValue) <> 0 Then
      Apci54wInPort = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Apci54wOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
  Apci54wOutPort = False
  If hDLL <> 0 Then
    If Apci54OutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
      Apci54wOutPort = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P54̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Apci54wGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Apci54wGetLastError = APCI54_ERR_WRAPDLL
  Else
    Apci54wGetLastError = Apci54GetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Apci54wGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Apci54wGetDllExportFunc = False
  ' Apci54GetVersion ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54GetVersion")
  If pFunc = 0 Then Exit Function
  ' Apci54Create ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54Create")
  If pFunc = 0 Then Exit Function
  ' Apci54Close ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54Close")
  If pFunc = 0 Then Exit Function
  ' Apci54GetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54GetResource")
  If pFunc = 0 Then Exit Function
  ' Apci54GetSwitchValue ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54GetSwitchValue")
  If pFunc = 0 Then Exit Function
  ' Apci54GetDirections ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54GetDirections")
  If pFunc = 0 Then Exit Function
  ' Apci54SetDirections ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54SetDirections")
  If pFunc = 0 Then Exit Function
  ' Apci54InPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54InPort")
  If pFunc = 0 Then Exit Function
  ' Apci54OutPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54OutPort")
  If pFunc = 0 Then Exit Function
  ' Apci54GetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci54GetLastError")
  If pFunc = 0 Then Exit Function
  Apci54wGetDllExportFunc = True    ' SĂ DLL ߰Ċ֐ڽ擾
End Function


